(function ($) {
    $.fn.shyt = function (options) {

        var settings = {
            "API_KEY": null,
            "size": "medium",
            "attribute": "href",
            "wrap": false
        };

        if (options) {
            $.extend(settings, options);
        }

        function getVideoId(url) {
            var regExp = /^.*((youtu.be\/)|(v\/)|(\/u\/\w\/)|(embed\/)|(watch\?))\??v?=?([^#\&\?]*).*/;
            var match = url.match(regExp);
            return (match && match[7].length == 11) ? match[7] : false;
        }

        function getVideoThumbnail(data) {
            return data['items'][0]['snippet']['thumbnails'][settings.size]['url'];
        }

        $.each(this, function () {
            if ($(this).attr(settings.attribute)) {
                var youtubeUri = $(this).attr(settings.attribute),
                    videoId = getVideoId(youtubeUri),
                    that = this,
                    endpointUri = 'https://www.googleapis.com/youtube/v3/videos?id=' + videoId + '&key=' + settings.API_KEY + '&part=snippet';

                $.getJSON(endpointUri, function (data) {
                    var thumbnailUri = getVideoThumbnail(data);
                    var html;
                    if(settings.wrap) {
                        html = '<a href="'+ youtubeUri +'"><img src="'+thumbnailUri+'"></a>';
                    }else {
                        html = '<img src="' + thumbnailUri + '">';
                    }
                    $(that).html(html);
                });
            }
        });
    };
})(jQuery);